(function(){

if ( !YAHOO.util.Event.isSafari ) { return; }

var _eO = function(o,p,z) {
    this.thisObj = o;
    this.YGeoPoint = p;
    this.zoomObj = z;
};
YPolyline.prototype.setGeoXYPoint = function(_z,_a,_t) {
    // QQQQQQQQQQ
    // PAN is not done, or need not be done - in case of IE, others?
    // if _t == 2 return, but should adjust to wrap polyline around the world...
    // wrap world polyline is not done
    if (_t == 2) return;

    for (var s in this._segs) {
        if (this._segs[s]._ygpto) {
            var gp1 = this._segs[s]._ygpfrom;
            var gp2 = this._segs[s]._ygpto;
            
            // convert, 1 to note its polyline
            var pa = this._map._ll2xy(gp1,1);
            var pb = this._map._ll2xy(gp2,1);
            
            // starting or end point for segment not defined, not contained
            if (!pa.x || !pa.y || !pb.x || !pb.y) { return; }
			
			this._setFromTo(this._segs[s],pa,pb);
            
            // is this added multiple times and ok?
            if (!this._segs[s]._added) {
                // move to creation time
                this.dom.style.zIndex = 1;
                YUtility.appendNode(this.dom,this._segs[s]);
                this._segs[s]._added = true;
            }
			else if ( this._canvas &&  window.widget ) {
				YUtility.removeNode(this._segs[s]);
				this._segs[s] = this.cSeg(gp1,gp2);
                YUtility.appendNode(this.dom,this._segs[s]);
                this._segs[s]._added = true;
			}
        }
    }
};

YPolyline.prototype.draw = function() {
	if ( this._canvas ) {
		for (var s in this._segs) {
			if (this._segs[s]._added&& this._segs[s]._ygpto) {
				var gp1 = this._segs[s]._ygpfrom;
				var gp2 = this._segs[s]._ygpto;
				
				// convert, 1 to note its polyline
				var pa = this._map._ll2xy(gp1,1);
				var pb = this._map._ll2xy(gp2,1);
				
				// starting or end point for segment not defined, not contained
				if (!pa.x || !pa.y || !pb.x || !pb.y) { return; }
				
				this._setFromTo(this._segs[s],pa,pb);
			}
		}
	}
};
YPolyline.prototype._setFromTo = function(o,a,b) {
    /// IE_poly
    if (!YUtility.browser.id) {
        o.from = a.x+','+a.y;
        o.to = b.x+','+b.y;
    return;
    }
    /// SVG
    var minx = (a.x > b.x) ? b.x : a.x;
    var miny = (a.y > b.y) ? b.y : a.y;
    if (YUtility.browser.id && (this._svg || this._canvas)) {

        var mx = Math.abs(a.x-b.x)+this._weight*2;
        var my = Math.abs(a.y-b.y)+this._weight*2;
        mx = (mx>my)?mx:my;
        minx -=this._weight;
        miny -=this._weight;
        // required to position the box properly
        o.style.left = minx + 'px';
        o.style.top = miny + 'px';
        o.style.position = 'absolute';
        o.setAttribute('viewBox',minx+' '+miny+' '+mx+' '+mx);

		o.setAttribute('width',mx+'px');
		o.setAttribute('height',my+'px');
		
        // o.setAttribute('overflow','visible'); // ?why? not needed here
		if ( this._svg) {
			if (!o._yline) {
				// o._yline = document.createElementNS('http://www.w3.org/2000/svg', 'path');
				o._yline = document.createElementNS('http://www.w3.org/2000/svg', 'line');
				o._yline.setAttribute('stroke-linecap', 'round');
				o._yline.setAttribute('stroke-linejoin', 'round');
				o._yline.setAttribute('stroke-width', this._weight+'px');
				o._yline.setAttribute('stroke-opacity', this._alpha);
				o._yline.setAttribute('stroke', this._color);
				YUtility.appendNode(o,o._yline);
			}
			// path option
			// o._yline.setAttribute('d', 'M'+a.x+','+a.y+' L'+b.x+','+b.y);
			
			// line option
			if ( !YAHOO.util.Event.isSafari ) {
				o._yline.setAttribute('x1', a.x );
				o._yline.setAttribute('y1', a.y );
				o._yline.setAttribute('x2', b.x );
				o._yline.setAttribute('y2', b.y );
			}
			else {
			// SAFARI 3.0 Fix
				o._yline.setAttribute('x1', a.x -minx);
				o._yline.setAttribute('y1', a.y -miny);
				o._yline.setAttribute('x2', b.x -minx);
				o._yline.setAttribute('y2', b.y -miny);
			}
		}
		else if ( this._canvas ) {
			var ctx = o.getContext('2d');
			ctx.save();
			ctx.lineWidth = this._weight ;
			ctx.lineCap = 'round';
			ctx.lineJoin= 'round';
			ctx.strokeStyle = this._color;
			ctx.globalAlpha = this._alpha;

			ctx.beginPath();
			ctx.moveTo(a.x-minx,a.y-miny);
			ctx.lineTo(b.x-minx,b.y-miny);
			ctx.stroke();

			ctx.closePath();
			ctx.restore();
		}
		return;
    }
    /// Canvas?
    // if canvas do canvas and return - safari?
    
    /// Image request
    o.src = YMapConfig.polyLine+'x='+a.x+'|'+a.y+'&y='+b.x+'|'+b.y;
    if (YUtility.browser.id) {
        YUtility.setStyle(o,'cursor','move');
        YUtility.setStyle(o,'visibility','hidden');
        o.onload = function(){
            YUtility.setStyle(o,'visibility','visible');
        };
    }
    o.style.position = 'absolute';
    o.style.left = minx + 'px';
    o.style.top = miny +'px';
};
YPolyline.prototype.cSeg = function(a,b) {
    var _l=_s=[];

    /// IE_poly
    if (!YUtility.browser.id) {
        _l = document.createElement('v:line');
        _l.strokecolor = this._color;
        _l.strokeweight = this._weight+'px';
        _s = document.createElement('v:stroke');
        _s.opacity = this._alpha;
        _s.endcap = 'round';
        YUtility.appendNode(_l,_s);
    }

    // SVG: ffox,opera, mac OR Canvas (if processed)
    if (YUtility.browser.id) {
        // create SVG node
		_l = document.createElementNS('http://www.w3.org/2000/svg','svg');
		// typeof _l.x == 'object'
		if (_l.x && _l.y) {
			YUtility.setStyle(_l,'cursor','move');
			// moved to from-to - review
			// _l.style.border = 'dashed';
			// _l.viewBox = '-1000 -1000 1000 1000';
			// _l.style.position = 'absolute';
			// _l.style.left = '-100px';
			// _l.style.top = '-100px';
			// _l.style.width = '100%';
			// _l.style.height= '100%';
			// _l.width = '100%';
			// _l.height = '100%';
			// _l.overflow = 'visible';
			this._svg = true;
		}
		else if ( window.CanvasRenderingContext2D || YAHOO.util.Event.isSafari ) {
			_l = document.createElement('canvas');
			this._canvas = true;
			if ( _l.getContext('2d')) {
				YUtility.setStyle(_l,'cursor','move');
			}
		}

		// nothing left but image
		else {
			// else nothing caught
			_l = YUtility.createNode('img');
		}
    }   
    // generic
    _l._ygpfrom = a;
    _l._ygpto = b;
    return _l;
};  
YMap.prototype._adjustOverlay= function(t) {
    // markers
        for (var m in this._mTb) {
                if (this._mTb[m].setGeoXYPoint) {
                        this._mTb[m].setGeoXYPoint(this.zoomLevel,this._posTbl,t);
                }
        }

    // polylines
    if (t!=2)
        for (var p in this._pTb) {
        if (this._pTb[p].setGeoXYPoint) {
                        this._pTb[p].setGeoXYPoint(this.zoomLevel,this._posTbl,t);
                        this._pTb[p].draw();
        }
    }
};
YMap.prototype.addOverlay = function(o) {
    if (!o) throw("Error: attempting to add invalid overlay object!");
    if (o.YGeoPoint) {
        o.setMapObject(this);
        o.setGeoXYPoint(this.zoomLevel,this._posTbl);

        // polyline overlay case
        if (o.polyline && !this._pTb[o.id]) {
            // QQQQQQQQQQQQ
            // YUtility.appendNode(this._canvas,o);

            YUtility.appendNode(this.subContainer,o);
			if ( o._canvas ) { o.draw(); }

            // store in polyline table
            this._pTb[o.id] = o;

            // trigger polyline added
            var _ce=new _eO(this,this.YGeoPoint);
            this.Events.polylineAdded.trigger(_ce);
        }
        // markers overlay case
        else if(!this._mTb[o.id])  {
            YUtility.appendNode(this.subContainer,o);
            // add to table
                    this._mTb[o.id]=o;
        }

        // TBD var pt = o.getCoordPoint();
    }
    else if (o.YCoordPoint) {
        o.setMapObject(this);
        o.assignCoordPoint();

        if(!this._coordTable)
            this._coordTable=[];

        if(!this._coordTable[o.id])
            YUtility.appendNode(this, o);

        // add to table
        this._coordTable[o.id]=o;
    }
    else if(o.GeoRSS) {
        this._startGeoRSS(o,1);
    return;
    }

    // Check if alpha needs to be adjusted
    // adjust alpha here  - go recursive for deeply nested objects - TBD
    YUtility.alphaLoad(o);
};
})();
